(require "ni/setup")

(provide "ni/update-xyzzy")
(in-package "netinst")

(defvar *latest-xyzzy-info-url*
  "https://raw.github.com/mumurik/xyzzy/master/latest-xyzzy-info.l"
  "ŐVłxyzzy̔zz̏̓t@CւURLBpackages.lƓtH[}bgzB")

(defvar *installed-xyzzy-info-file*
  (merge-pathnames "installed-xyzzy-info.l" *base-directory*)
  "݃CXg[Ăxyzzypackages.l̃t@C̕ۑĂpXB
CXg[݂͑Ȃ̂ŒӁB")

(defvar *latest-xyzzy-info-file*
  (merge-pathnames "latest-xyzzy-info.l" *base-directory*)
  "ŐVpackages.l̃t@C̕ۑĂpXB")

(defvar *xhr* nil)

#-multiple-frames
(defun safe-data-read (file)
  (when (file-exist-p file)
    (when (check-read-time-eval file)
      (ni-error "sȃt@Cł: ~%~A" file))
    (data-read-from-file file)))

#+multiple-frames
(defun safe-data-read (file)
  (when (file-exist-p file)
    (handler-case
	(data-read-from-file file)
      (reader-error (c)
	(ni-error "sȃt@Cł: ~%~A" file)))))

(defun load-installed-xyzzy-info ()
"CXg[ĂxyzzyɊւsiteԂBsite-*ŗvfɂ̓ANZXłB
srcĂ鎖͕ۏႳȂB"
  (safe-data-read *installed-xyzzy-info-file*))

(defun load-latest-xyzzy-info ()
"ŐVxyzzyɊւsiteԂBsite-*ŗvfɂ̓ANZXłB
srcĂ鎖͕ۏႳȂB"
  (safe-data-read *latest-xyzzy-info-file*))



(defun https-get-to-file (url file)
"url̓efileɃoCiŕۑBfile̓tpX
UɑSēǂݍނ̂ő傫ȃt@Cł͎gȂłB
httpshttpւredirecteĂ܂B
nȉꍇhashr̂ŔrISłAȊO̗prɎgꍇ͒ӁB"
  (unless *xhr*
    (setq *xhr* (ole-create-object "WinHttp.WinHttpRequest.5.1")))
  (when *https-proxy-url*
    (ole-method *xhr* 'SetProxy 2 *https-proxy-url*)) ;HTTPREQUEST_PROXYSETTING_PROXY 2
  (long-operation
    (ole-method *xhr* 'open "GET" url nil) ;; non-blocking and just sleep never change state. so use as blocking.
    (ole-putprop *xhr* 'Option t 6) ; enable redirect 6
    (ole-putprop *xhr* 'Option t 12) ;EnableHttpsToHttpRedirects 12
    (ole-method *xhr* 'setRequestHeader "If-Modified-Since" "Thu, 01 Jun 1970 00:00:00 GMT") ; to invalidate cash
    (ole-method *xhr* 'send)
    (if (not (eq (ole-method *xhr* 'status) 200))
	(progn
	  (message-box "A[JCu̎擾Ɏs܂")
	  ; for debug (setq *xhr* nil)
	  nil)
      (let ((dir (directory-namestring file))
	    (stream (ole-create-object "ADODB.Stream")))
	(unless (file-exist-p dir)
	  (create-directory dir))
	(ole-putprop stream 'Type 1)
	(ole-method stream 'Open)
	(ole-method stream 'Write (ole-method *xhr* 'responseBody))
	(ole-method stream 'SaveToFile file 2) ;; overwrite
	(ole-method stream 'Close)
	t))))
  
(defun update-latest-xyzzy-info ()
"ŐVłpackages.l̃t@C_E[hB"
  (https-get-to-file *latest-xyzzy-info-url* *latest-xyzzy-info-file*)
  t)

(defun newer-version-exist-p ()
"ŐVłmd5VłƂ݂ȂB[Jmd5ΐVłƂ݂ȂB
CXg[ɂmd5̂łtB"
  (let ((installed (installed-xyzzy-app)))
    (if installed
	(not (equal (app-md5 (installed-xyzzy-app))
		    (app-md5 (latest-xyzzy-app))))
	t)))

(defun xyzzy-info-to-app (info)
"xyzzyɊւsitexyzzypackages̗vfԂBԖڂ̗vfƌߑł"  
  (if info
      (car (site-apps info))))

(defun latest-xyzzy-app ()
  (xyzzy-info-to-app (load-latest-xyzzy-info)))

(defun installed-xyzzy-app ()
  (xyzzy-info-to-app (load-installed-xyzzy-info)))

(defun fetch-latest-xyzzy-archive (latestapp)
"ŐVarchive擾md5`FbNAvtԂB
install-app-fetchƂقƂǓǁAߋarchive͊ɍ폜ς݂Ȃ̂ႤB"
  (let ((file (app-src-file latestapp)))
    (unless (https-get-to-file (app-src latestapp) file)
      (return-from fetch-latest-xyzzy-archive))
    (if (app-src-md5sum-check latestapp)
	t
      (progn
	(delete-file file)
	nil))))

(defun update-xyzzy ()
  (let ((latestapp (latest-xyzzy-app)))
    (unless (fetch-latest-xyzzy-archive latestapp)
      (return-from update-xyzzy))
    (extract-archive (app-src-file latestapp) (si:system-root))
    (delete-file (app-src-file latestapp)
    (copy-file *latest-xyzzy-info-file* *installed-xyzzy-info-file* :if-exists :overwrite) 
    (case (message-box "Nxyzzy͍XV܂BċN܂H" nil
		       '(:yes-no :question :button1))
      (:yes (ed:restart-for-update))
      (:no nil)))))
  


(defun editor::check-update()
  (interactive)
  (update-latest-xyzzy-info)
  (if (newer-version-exist-p)
      (case (message-box "Vo[W܂BXV܂H" nil
			 '(:yes-no :question :button1))
	(:yes (update-xyzzy))
	(:no (return-from check-update)))
    (progn
     (message-box "g̃o[W͍ŐVo[WłB")
      (return-from check-update))))



